<template>
  <div class="relative" v-click-outside="closeDroplist">
    <div
      class="h-16 rounded-24 bg-btndsec flex items-center justify-between pl-4 pr-5 gap-3 cursor-pointer"
      :class="isDroplistVisible ? 'shadow-inpdfoc' : 'hover:shadow-inpdhov'"
      @click="openDroplist"
    >
      <img :key="value.key" width="32" height="32" :src="require(`@/assets/images/coins/${value.key.toLowerCase()}.svg`)" />
      <p class="text-txtdprim font-medium flex-1">{{ value.title }}</p>
      <img
        :style="`transform: rotate(${isDroplistVisible ? '180' : '0'}deg)`"
        width="24"
        height="24"
        src="@/assets/images/ui/ui-drop.svg"
      />
    </div>
    <div
      v-show="isDroplistVisible"
      class="ui-dropdown__menu absolute top-20 left-0 w-full bg-bgdprim p-4 rounded-32 z-2"
    >
      <UiInput v-model="searchValue" placeholder="Search" input-height="12" input-radius="16" class="w-full">
        <img width="24" height="24" src="@/assets/images/ui/ui-search.svg" />
      </UiInput>
      <div
        style="max-height: 280px"
        class="ui-dropdown__scroll-wrapper mt-4 p-1 overflow-auto pr-4 flex flex-col gap-2"
        :class="{ hidden: filteredOptions.length === 0 }"
      >
        <UiButton
          v-for="(option, index) in filteredOptions"
          :key="option.key + index"
          button-height="sm"
          color-type="transparent"
          class="gap-3 text-sm leading-6 rounded-16 px-2 shrink-0"
          @click="handleOptionClick(option)"
        >
          <img width="32" height="32" :src="require(`@/assets/images/coins/${option.key.toLowerCase()}.svg`)" />
          <p class="flex-1 font-medium text-sm leading-6 text-txtdsec">{{ option.title }}</p>
          <img v-show="option.key === value.key" width="24" height="24" src="@/assets/images/ui/ui-check.svg" />
        </UiButton>
      </div>
    </div>
  </div>
</template>

<script>
import UiInput from '@/components/ui/UiInput.vue';
import UiButton from '@/components/ui/UiButton.vue';

export default {
  name: 'UiDropdown',

  components: { UiInput, UiButton },

  data() {
    return {
      isDroplistVisible: false,

      searchValue: '',
    };
  },

  computed: {
    filteredOptions() {
      return this.$props.options.filter(
        (option) =>
          option.title.toLowerCase().includes(this.searchValue.toLowerCase()) ||
          option.key.toLowerCase().includes(this.searchValue.toLowerCase())
      );
    },
  },

  props: {
    options: {
      type: Array,
      default: () => [],
    },

    value: {
      type: Object,
      default: () => ({}),
      required: true,
    },
  },

  methods: {
    openDroplist() {
      this.isDroplistVisible = !this.isDroplistVisible;
    },

    closeDroplist() {
      this.searchValue = '';
      this.isDroplistVisible = false;
    },

    handleOptionClick(option) {
      this.$emit('input', option);
      this.closeDroplist();
    },
  },
};
</script>

<style lang="scss">
.ui-dropdown {
  &__menu {
    box-shadow: 0px 8px 32px 0px #435a7b14;
  }

  &__scroll-wrapper {
    scrollbar-width: thin;
    scrollbar-color: #17283e transparent;

    &::-webkit-scrollbar {
      width: 8px;
      height: 8px;
      margin-top: 8px;
    }

    &::-webkit-scrollbar-thumb {
      background: #17283e;
      border-radius: 10px;
      cursor: pointer;
      margin-top: 8px;
    }

    &::-webkit-scrollbar-corner {
      display: none;
    }

    &::-webkit-scrollbar-track {
      background: transparent;
    }
  }
}
</style>
